plugin simpleObject boxBetween2points
name:"boxBetween2points"
classID:#(0xf608e3e, 0x9efd28a)
category:"oliverh"

( 

local box1, box2

parameters main rollout:params

(

pnt1 type:#string
pnt2 type:#string
startpoint type:#point3
endpoint type:#point3

_length type:#worldUnits ui:_length default:1E-3
_width type:#worldUnits ui:_width default:1E-3
_height type:#worldUnits 
_heightSegments type:#integer ui:_heightSegments default:1
)

rollout params "boxBetween2points"

(

--spinner _height "Height" type:#worldUnits range:[1E-3,1E9,1E-3]

spinner _width "Width" type:#worldUnits range:[1E-3,1E9,1E-3]

spinner _length "Length" type:#worldUnits range:[-1E9,1E9,1E-3]

spinner _heightSegments "Height Segs" range:[1,100,10] type:#integer
)

on buildMesh do

(

if box1 == undefined then
(
box1 = createInstance box
)

box1.height = _height; 

box1.width = _width; 

box1.length = _length; 

box1.heightsegments = _heightSegments;

update box1.mesh
mesh = box1.mesh

)

tool create

(

on mousePoint click do

case click of

(

1: (
nodeTM.translation = gridPoint
p1 = point()
p1.pos = gridPoint
pnt1 = "$"+p1.name
startpoint = gridPoint
)

3: (
p2 = point()
p2.pos = gridPoint
pnt2 = "$"+p2.name
endpoint = gridPoint
$.position.controller=position_script()
$.position.controller.script = ("try (\n dependsOn "+pnt1+"\n"+pnt1+".pos \n) catch ( [0,0,0] )")						
$.rotation.controller=rotation_script()
$.rotation.controller.script = ("try (\n
dependsOn "+pnt1+" "+pnt2+"\np1= "+pnt1+".pos"+"\np2= "+pnt2+".pos;\n
pxx = ((p1.x-p2.x)*(p1.x-p2.x));

pyy = ((p1.y-p2.y)*(p1.y-p2.y));

if (p1.x >= p2.x) then (

hypp = sqrt(pxx+pyy);

) else (

hypp = -sqrt(pxx+pyy);

)

yd =  (atan((hypp/(p1.z-p2.z))));
zd =  (atan((p1.y-p2.y)/(p1.x-p2.x)));
xd = 0;

if (p1.x >= p2.x) then (
xd += 180
if (p1.z < p2.z) then (
yd -= 180
) 
) else (
if (p1.z >= p2.z) then (
yd += 180
)
)

eulerToQuat (eulerangles xd (yd) (zd))
)catch(quat (0 0 0 0))")

							
$._height.controller = float_script()
$._height.controller.script = ("try (\ndependsOn "+pnt1+" "+pnt2+"\nlength ([("+pnt2+".pos.x-"+pnt1+".pos.x),("+pnt2+".pos.y-"+pnt1+".pos.y),("+pnt2+".pos.z-"+pnt1+".pos.z)])\n) catch ( 0 )")

#stop
)

)

on mouseMove click do
case click of
(
2: (
_width = abs gridDist.x
_length = abs gridDist.y
)
)

)

)
